using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Utilities.BookingGroup.Cqrs;

public class GetBookingGroupListResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetBookingGroupListQuery() : IRequest<List<GetBookingGroupListResponse>>;

public class GetBookingGroupListHandler : IRequestHandler<GetBookingGroupListQuery, List<GetBookingGroupListResponse>>
{
    private readonly AppDbContext _context;

    public GetBookingGroupListHandler(AppDbContext context) => _context = context;

    public async Task<List<GetBookingGroupListResponse>> Handle(GetBookingGroupListQuery request, CancellationToken cancellationToken)
    {
        return await _context.BookingGroup
            .AsNoTracking()
            .OrderBy(x => x.Name)
            .Select(x => new GetBookingGroupListResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy
            })
            .ToListAsync(cancellationToken);
    }
}